<?php

namespace Drupal\mcapi_credcom\Controller;
use \Drupal\mcapi\Entity\Type as McType;
use Drupal\Core\Render\Markup;
use Drupal\Core\Link;
use Drupal\Core\Url;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Community accounting menu / admin page showing workflow info at the top.
 */
class AccountingAdmin extends \Drupal\mcapi\Controller\AccountingAdmin {

  /**
   * {@inheritDoc}
   */
  public function systemAdminMenuBlockPage() {
    $page = parent::systemAdminMenuBlockPage();
    $page['types']['#items'] = [];
    foreach (McType::loadMultiple() as $mcType) {
      if (empty($mcType->disabled)) {
        $op = $mcType->local ? 'edit' : 'localedit';
        $scope = $mcType->local ? t('Edit') : t('Localise');
        $url = Url::fromRoute('entity.mc_type.'.$op, ['mc_type'=> $mcType->id]);
        $link = Link::fromTextAndUrl($mcType->label, $url);
      }
      else {
        $link = $mcType->label;
      }
      $string = $link->toString() .': '. $mcType->summary .' ('.$scope.')';
      $page['types']['#items'][] = Markup::create($string);
    }

    return $page;
  }

}
