<?php

namespace Drupal\mcapi_credcom\Controller;

use Drupal\mcapi\Entity\Wallet;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Drupal\mcapi_credcom\TrunkwardNodeRequester;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Return wallet names to the autocomplete wallet field.
 */
class Names extends \Drupal\Core\Controller\ControllerBase {

  /**
   * @var TrunkwardNodeRequester
   */
  protected $trunkwardNode;


  public function __construct(TrunkwardNodeRequester $trunkward_requester) {
    $this->trunkwardNode = $trunkward_requester;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('mcapi_credcom.trunkward_node'),
    );
  }

  function remote(Request $request) {
    $fragment = $request->query->get('q');
    $names = $this->trunkwardNode->accountNameFilter($fragment);
    return new JsonResponse($names);
  }

  function all(Request $request) {
    $local_names = [];
    $fragment = $request->query->get('q');
    $walletQuery = $this->entityTypeManager()->getStorage('mc_wallet')->getQuery()->accessCheck(TRUE);
    if (is_numeric($fragment)) {
      $walletQuery->condition('wid', "$fragment%", 'LIKE');
    }
    else {
      $walletQuery->condition('name', "%$fragment%", 'LIKE');
    }
    if ($wids = $walletQuery->accesscheck(TRUE)->execute()) {
      foreach (Wallet::loadMultiple($wids) as $wid => $wallet) {
        $local_names[] = $wallet->label() .' ('.$wid.')';
      }
    }
    $remote_names = $this->trunkwardNode->accountNameFilter($fragment);
    return new JsonResponse(array_merge($local_names, $remote_names));
  }

}
