<?php
namespace Drupal\mcapi_forms\EventSubscriber;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Subscriber to create a router item for each transaction form display.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritDoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    if (\Drupal::config('mcapi.settings')->get('hide_default_transaction_tabs')) {
      //hide the default transaction forms from normal users
      $collection->get('entity.mc_transaction.add_form')
        ->addRequirements(['_permission' => 'manage mcapi', '_permission' => 'manage mcapi']);
    }
  }

}

