<?php

namespace Drupal\mcapi_limits\Plugin\Field;

use Drupal\Core\Field\FieldItemList;

/**
 * A signature field list
 */
class LimitsFieldItemList extends FieldItemList {

  function getBaseLimits() {
    $config = \Drupal::config('mcapi_limits.settings');
    return \Drupal::service('plugin.manager.mcapi_limits')
      ->createInstance($config->get('plugin'), $config->get('plugin_settings')[$config->get('plugin')])
      ->getLimits($this->getEntity());
  }

  /**
   * Get the minimum allowed balance for this wallet.
   */
  function min() {
    if ($this->min <> NULL) return $this->min;
    return $this->getBaseLimits()['min'];
  }

  /**
   * Get the maximum allowed balance for this wallet
   */
  function max() {
    if ($this->max <> NULL) return $this->max;
    return $this->getBaseLimits()['max'];
  }


}
