<?php

namespace Drupal\mcapi\Entity;

use Drupal\Core\Config\Entity\ConfigEntityBase;

/**
 * Defines the transaction type entity class, i.e. the workflow definition.
 *
 * @ConfigEntityType(
 *   id = "mc_type",
 *   label = @Translation("Transaction type"),
 *   config_prefix = "mc_type",
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label",
 *   },
 *   handlers = {
 *     "form" = {
 *       "edit" = "Drupal\mcapi\Form\WorkflowEdit"
 *     }
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *     "summary",
 *     "local",
 *     "creation",
 *     "direction",
 *     "states"
 *   }
 * )
 * @todo make an edit form with a link to it and validation
 */
class Type extends ConfigEntityBase {

  const CREDIT = 'credit';
  const BILL = 'bill';
  const THIRDPARTY = '3rdparty';

  /**
   * Unique ID
   * @var string
   */
  public string $id;

  /**
   * Name to show in lists
   * @var string
   */
  public string $label;

  /**
   * Short description
   * @var string
   */
  public string $summary;

  /**
   * Whether this workflow originates locally
   * @var bool
   */
  public bool $local;

  /**
   * Whether this is BILL or CREDIT or THIRDPARTY
   * @var string
   */
  public string $direction;

  /**
   * Creation parameters.
   * @var stdClass with properties string state, and bool confirm
   */
  public $creation;

  /**
   * Structured data
   * @var array
   */
  public array $states;

}
