<?php

namespace Drupal\mcapi;

use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\mcapi\Entity\Type;

/**
 * Provides dynamic permissions for nodes of different types.
 */
class Permissions {
  use StringTranslationTrait;

  /**
   * Returns an array of transaction type permissions.
   *
   * @return array
   *   The node type permissions.
   *   @see \Drupal\user\PermissionHandlerInterface::getPermissions()
   */
  public function transactionTypePermissions() {
    $perms = [];
    foreach (Type::loadMultiple() as $type) {
      $perms["create $type->id transaction"] = [
        'title' => $this->t('Create %type transaction', ['%type' => $type->label]),
        'description' => $type->summary
      ];
    }
    return $perms;
  }

}
